create or replace PROCEDURE ESTIMA_META(
	V_CDFILIAL  IN VARCHAR2,  
    V_NRORG     IN NUMBER, 
    V_PERCACRES IN FLOAT,
	V_PERIODO   IN VARCHAR2 DEFAULT 'N', 
    V_DTINI     IN VARCHAR2 DEFAULT NULL, 
    V_DTFIN     IN VARCHAR2 DEFAULT NULL,
	P_CDANO     IN NUMBER   DEFAULT 0
)
AS
  TYPE TDIAS  IS VARRAY(7) OF FLOAT;
  TYPE THORAS IS VARRAY(24) OF FLOAT;
  V_NRDIA           NUMBER;
  V_CDMES           NUMBER;
  V_CDANO           NUMBER;
  V_CONTHORA        NUMBER;
  V_CONTADOR        NUMBER;
  V_VNDREALIZADAS   NUMBER;
  V_DIASDASEMANA	NUMBER;
  V_DIASDASEMANAANT	NUMBER;
  V_TOT_VND_DIA     FLOAT;
  V_EST_CMD         FLOAT;
  V_EST_TAA         FLOAT;
  V_EST_DLV         FLOAT;
  V_EST_BAL         FLOAT;
  V_EST_MES         FLOAT;
  V_EST_OUT         FLOAT;
  V_VND_PROV        FLOAT;
  V_VND_PROV2       FLOAT;
  V_VENDASEMANA		FLOAT;
  V_TOTVENDAMES     FLOAT;
  V_TICKETMEDIO     FLOAT;
  V_TOTALVEND       FLOAT;
  V_PESSOAS         FLOAT;
  V_VALORES		    TDIAS;
  V_HORAS           THORAS;
BEGIN
	IF (P_CDANO < TO_NUMBER(TO_CHAR(SYSDATE, 'YYYY')-1))  THEN
		V_CDANO := TO_NUMBER(TO_CHAR(SYSDATE, 'YYYY'));
	ELSE
		V_CDANO := P_CDANO;
	END IF;
	DELETE FROM METAHORA 
        WHERE CDFILIAL = V_CDFILIAL 
            AND CDANO = V_CDANO;
	DELETE FROM METAMODALIDADEDIA 
        WHERE CDFILIAL = V_CDFILIAL 
            AND CDANO = V_CDANO;
	DELETE FROM METADIA 
        WHERE CDFILIAL = V_CDFILIAL 
            AND CDANO = V_CDANO;
	DELETE FROM METAMES 
        WHERE CDFILIAL = V_CDFILIAL 
            AND CDANO = V_CDANO;
	FOR C_FERIADO IN(
        SELECT DSFERIFILI, DTFERIFILI 
            FROM FERIFILI 
            WHERE CDFILIAL = V_CDFILIAL 
                AND NRORG = V_NRORG 
                AND TO_NUMBER(TO_CHAR(DTFERIFILI, 'YYYY')) =  V_CDANO
    ) LOOP
		BEGIN
			SELECT COUNT(CDFILIAL) INTO V_CONTADOR 
				FROM METADIAESPECIAL
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRORG = V_NRORG 
					AND TRUNC(DATAESP) = TRUNC(C_FERIADO.DTFERIFILI);
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_CONTADOR := 0;
		END;
		IF V_CONTADOR = 0 THEN
			INSERT INTO METADIAESPECIAL (CDFILIAL, DATAESP, PERCCORRECAO, DSMETAESP, NRORG)
				VALUES (V_CDFILIAL, C_FERIADO.DTFERIFILI, V_PERCACRES, C_FERIADO.DSFERIFILI, V_NRORG);
		END IF;
	/* END FOR */
	END LOOP;
	-- MÊS
	FOR K IN 1..12 LOOP
		V_CDMES 	  := K;
		V_VALORES     := TDIAS(0, 0, 0, 0, 0, 0, 0);
		V_VENDASEMANA := 0;
		V_TOTVENDAMES := 0;

		INSERT INTO METAMES (CDFILIAL, CDMES, CDANO, VRMES, VRSEM, NRORG)
			VALUES (V_CDFILIAL, V_CDMES, V_CDANO, 0, 0, V_NRORG);

		-- DIAS DA SEMANA
		FOR J IN 1..7 LOOP
			V_NRDIA := J;
			V_HORAS := THORAS(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
			V_CONTADOR      := 0;
			V_VNDREALIZADAS := 0;
			V_DIASDASEMANA  := 0;
			V_VND_PROV2     := 0;
			V_TICKETMEDIO   := 0;
			V_VND_PROV      := 0;
			V_EST_CMD       := 0;
			V_EST_TAA       := 0;
			V_EST_DLV       := 0;
			V_EST_BAL       := 0;
			V_EST_MES       := 0;
			V_EST_OUT       := 0;
			V_TOTALVEND     := 0;
			V_PESSOAS       := 0;

			/* CALCULA PREVISAO DE VENDA PARA O DIA (GERAL) */
			FOR C_VENDA IN(   
				SELECT CDFILIAL, NMFILIAL, IDORIGEMVENDA, DTENTRVENDA, NRORG,
						TOTALVEND, HORAVEND, NRPESSOAS, TICKETMEDIO
					FROM (
						SELECT PARCIAL.CDFILIAL, PARCIAL.NMFILIAL, PARCIAL.IDORIGEMVENDA, PARCIAL.DTENTRVENDA, PARCIAL.NRORG,
								SUM(NVL(PARCIAL.VRVENDA, 0)) AS TOTALVEND, PARCIAL.HORAVEND,
								SUM(NVL(PARCIAL.NRPESMESAVENDA, 1)) AS NRPESSOAS, TICKETMEDIO
							FROM (
									SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, F.NMFILIAL, V.NRPESMESAVENDA,
											TO_NUMBER(TO_CHAR(DTVENDA, 'HH24')) AS HORAVEND,
											V.IDORIGEMVENDA, V.NRORG, V.DTENTRVENDA, V.IDSITUVENDA,
											NVL(SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) / DECODE(V.NRPESMESAVENDA, 0, 1, V.NRPESMESAVENDA), 0) AS TICKETMEDIO,
											SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS VRVENDA
										FROM VENDA V
										LEFT JOIN FILIAL F
											ON V.CDFILIAL = F.CDFILIAL
										LEFT JOIN ITEMVENDA IT
										ON V.CDFILIAL = IT.CDFILIAL
											AND V.CDCAIXA    = IT.CDCAIXA
											AND V.NRORG      = IT.NRORG
											AND V.NRSEQVENDA = IT.NRSEQVENDA
										WHERE V.CDFILIAL     = V_CDFILIAL
											AND (V_NRDIA     = TO_CHAR(V.DTENTRVENDA,'D'))
											AND (V_CDMES     = TO_NUMBER(TO_CHAR(V.DTENTRVENDA, 'MM')) OR V_PERIODO = 'S')
											AND ((V_CDANO - 1) = TO_NUMBER(TO_CHAR(V.DTENTRVENDA, 'YYYY')) OR V_PERIODO = 'S')
											AND (V.DTENTRVENDA BETWEEN TO_DATE(V_DTINI, 'DD/MM/YYYY') AND TO_DATE(V_DTFIN, 'DD/MM/YYYY') OR V_PERIODO = 'N')
											AND V.IDSITUVENDA = 'O'
										GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, F.NMFILIAL, V.NRPESMESAVENDA, 
												DTVENDA, V.IDORIGEMVENDA, V.NRORG, V.DTENTRVENDA, V.IDSITUVENDA
									ORDER BY 1, 2, 3
								) PARCIAL
							GROUP BY PARCIAL.CDFILIAL, PARCIAL.NMFILIAL, PARCIAL.IDORIGEMVENDA, PARCIAL.DTENTRVENDA, 
									PARCIAL.HORAVEND, PARCIAL.NRORG, PARCIAL.TICKETMEDIO
					) FINAL
					GROUP BY CDFILIAL, NMFILIAL, IDORIGEMVENDA, DTENTRVENDA, HORAVEND, NRORG, NRPESSOAS, 
							TOTALVEND, TICKETMEDIO
			) LOOP
				V_CONTADOR := V_CONTADOR + 1;

				/* APLICA UM VALOR X A MAIS NO VALOR VENDIDO */
				V_VNDREALIZADAS := C_VENDA.TOTALVEND + ((V_PERCACRES/100) * C_VENDA.TOTALVEND);
				V_HORAS(C_VENDA.HORAVEND + 1) := V_HORAS(C_VENDA.HORAVEND + 1) + V_VNDREALIZADAS;
				V_TOTALVEND := V_TOTALVEND + C_VENDA.TOTALVEND;
				V_PESSOAS := V_PESSOAS + C_VENDA.NRPESSOAS;

				IF C_VENDA.IDORIGEMVENDA = 'CMD' THEN
					V_EST_CMD  := V_EST_CMD + V_VNDREALIZADAS;
				ELSIF C_VENDA.IDORIGEMVENDA = 'TAA' THEN
					V_EST_TAA  := V_EST_TAA + V_VNDREALIZADAS;
				ELSIF C_VENDA.IDORIGEMVENDA = 'DLV' THEN
					V_EST_DLV  := V_EST_DLV + V_VNDREALIZADAS;
				ELSIF C_VENDA.IDORIGEMVENDA = 'BAL' THEN
					V_EST_BAL  := V_EST_BAL + V_VNDREALIZADAS;
				ELSIF C_VENDA.IDORIGEMVENDA = 'MES' THEN
					V_EST_MES  := V_EST_MES + V_VNDREALIZADAS;
				ELSE
					V_EST_OUT  := V_EST_OUT + V_VNDREALIZADAS;
				END IF;
			/* END FOR */
			END LOOP;

			IF V_CONTADOR > 0 THEN
				V_TICKETMEDIO := V_TOTALVEND / V_PESSOAS;
				V_TICKETMEDIO := (V_TICKETMEDIO + ((V_PERCACRES/100) * V_TICKETMEDIO));

				SELECT COUNT(*) INTO V_DIASDASEMANAANT
					FROM DATA
					WHERE TO_CHAR(DTDATA, 'D') = V_NRDIA
						AND (TO_CHAR(DTDATA, 'MM')   = V_CDMES   OR V_PERIODO = 'S')
						AND (TO_CHAR(DTDATA, 'YYYY') = V_CDANO-1 OR V_PERIODO = 'S')
						AND (DTDATA BETWEEN TO_DATE(V_DTINI, 'DD/MM/YYYY') AND TO_DATE(V_DTFIN, 'DD/MM/YYYY') OR V_PERIODO = 'N');

				/* REALIZA A META DAS VENDAS SOMADAS DE UM DETERMINADO DIA. */
				V_VNDREALIZADAS := (V_EST_CMD + V_EST_TAA + V_EST_DLV + V_EST_BAL + V_EST_MES + V_EST_OUT)/ V_DIASDASEMANAANT;

				SELECT COUNT(*) INTO V_DIASDASEMANA
					FROM DATA
					WHERE TO_CHAR(DTDATA, 'D')      = V_NRDIA
						AND TO_CHAR(DTDATA, 'MM')   = V_CDMES
						AND TO_CHAR(DTDATA, 'YYYY') = V_CDANO;

				/* NESSE MOMENTO, A VARIAVEL V_VNDREALIZADAS ESTÃ¡OM UMA MÃ©A DE VENDA POR DIA DA SEMANA. */
				IF(V_VNDREALIZADAS > 0) THEN
					IF V_PERIODO = 'N' THEN
						V_TICKETMEDIO := V_TICKETMEDIO/V_DIASDASEMANA;
						V_EST_CMD := ((V_EST_CMD/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
						V_EST_TAA := ((V_EST_TAA/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
						V_EST_DLV := ((V_EST_DLV/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
						V_EST_BAL := ((V_EST_BAL/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
						V_EST_MES := ((V_EST_MES/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
						V_EST_OUT := ((V_EST_OUT/V_DIASDASEMANA) * 100) / V_VNDREALIZADAS;
					ELSE
						V_EST_CMD := ((V_EST_CMD/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
						V_EST_TAA := ((V_EST_TAA/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
						V_EST_DLV := ((V_EST_DLV/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
						V_EST_BAL := ((V_EST_BAL/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
						V_EST_MES := ((V_EST_MES/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
						V_EST_OUT := ((V_EST_OUT/V_DIASDASEMANAANT) * 100) / V_VNDREALIZADAS;
					END IF;
				ELSE
					V_EST_CMD := 0;
					V_EST_TAA := 0;
					V_EST_DLV := 0;
					V_EST_BAL := 0;
					V_EST_MES := 0;
					V_EST_OUT := 0;
				END IF;
			END IF;

			/* ATRIBUO AO ARRAY DE DIAS DA SEMANA O VALOR QUE DEVO VENDER EM UM DETERMINADO DIA DA SEMANA */
			V_VALORES(V_NRDIA) := V_VNDREALIZADAS;		
			V_VENDASEMANA := V_VENDASEMANA + V_VNDREALIZADAS;
			V_TOTVENDAMES := V_TOTVENDAMES + (V_VNDREALIZADAS * V_DIASDASEMANA);
			V_CONTADOR := 0;

			/* CONFERE SE EXISTE ALGUM REGISTRO NA METADIA E METAHORA. SE NAO HOUVER, INSERE.
			   SE NAO HOUVER NENHUM REGISTRO EM METADIA Ã©NTENDIDO QUE EM METAHORA TAMBEM NAO EXISTE. */
			BEGIN
				SELECT COUNT(CDFILIAL) INTO V_CONTADOR 
					FROM METADIA 
					WHERE NRDIA = V_NRDIA 
						AND CDMES    = V_CDMES 
						AND CDANO    = V_CDANO 
						AND CDFILIAL = V_CDFILIAL 
						AND NRORG    = V_NRORG;
			EXCEPTION
			WHEN NO_DATA_FOUND THEN
				V_CONTADOR := 0;
			END;

			IF V_CONTADOR = 0 THEN
				INSERT INTO METADIA (CDFILIAL, NRDIA, CDMES, CDANO, VRPERCDIA, VRTICKETDIA, NRORG)
					VALUES (V_CDFILIAL, V_NRDIA, V_CDMES, V_CDANO, TRUNC(100/7,2), 0, V_NRORG);

				V_CONTHORA := 0;

				WHILE V_CONTHORA <= 23 LOOP
					INSERT INTO METAHORA (CDFILIAL, CDHORA, NRDIA, CDMES, CDANO, VRPERCHORA, NRORG)
						VALUES (V_CDFILIAL, V_CONTHORA, V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
					V_CONTHORA := V_CONTHORA + 1;
				END LOOP;
			END IF;

			V_CONTADOR := 0;

			/* CONFERE SE EXISTE ALGUM REGISTRO NA METAMODALIDADE. SE NAO HOUVER, INSERE. */
			BEGIN
				SELECT COUNT(CDFILIAL) INTO V_CONTADOR 
					FROM METAMODALIDADEDIA 
					WHERE NRDIA = V_NRDIA 
						AND CDMES = V_CDMES 
						AND CDANO = V_CDANO 
						AND CDFILIAL = V_CDFILIAL 
						AND NRORG = V_NRORG;
			EXCEPTION
			WHEN NO_DATA_FOUND THEN
				V_CONTADOR := 0;
			END;

			IF V_CONTADOR = 0 THEN
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'CMD', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'TAA', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'DLV', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'BAL', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'MES', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
				INSERT INTO METAMODALIDADEDIA (CDFILIAL, IDMODALIDADE, NRDIA, CDMES, CDANO, VRPERCMODALIDADE, NRORG)
					VALUES (V_CDFILIAL, 'OUT', V_NRDIA, V_CDMES, V_CDANO, 0, V_NRORG);
			END IF;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE CMD */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_CMD
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'CMD' 
					AND NRORG = V_NRORG;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE TAA */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_TAA
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'TAA' 
					AND NRORG = V_NRORG;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE DLV */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_DLV
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'DLV' 
					AND NRORG = V_NRORG;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE BAL */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_BAL
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'BAL' 
					AND NRORG = V_NRORG;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE MES */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_MES
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'MES' 
					AND NRORG = V_NRORG;

			/* ATUALIZA A ESTIMATIVA DA MODALIDADE OUT */
			UPDATE METAMODALIDADEDIA 
				SET VRPERCMODALIDADE = V_EST_OUT
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = V_NRDIA 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND IDMODALIDADE = 'OUT' 
					AND NRORG = V_NRORG;

			FOR H IN 1..24 LOOP
				IF (V_VNDREALIZADAS > 0) THEN
					IF V_PERIODO = 'N' THEN
						V_HORAS(H) := (V_HORAS(H)/ V_DIASDASEMANA)*100/V_VNDREALIZADAS;
					ELSE
						V_HORAS(H) := (V_HORAS(H)/ V_DIASDASEMANAANT)*100/V_VNDREALIZADAS;
					END IF;
				ELSE
					V_HORAS(H) := 0;
				END IF;

				V_VND_PROV2 := V_VND_PROV2 + TRUNC(V_HORAS(H), 2);
			END LOOP;

			IF (V_VND_PROV2 < 100) THEN
				V_HORAS(24) := V_HORAS(24) + (100-V_VND_PROV2);
			ELSIF (V_VND_PROV2 > 100) THEN
				V_VND_PROV2 := V_VND_PROV2 - 100;

				FOR H IN 1..24 LOOP
					IF (V_HORAS(H) > V_VND_PROV2) THEN
						V_HORAS(H) := V_HORAS(H) - V_VND_PROV2;
						EXIT;
					END IF;
				END LOOP;
			END IF;

			V_CONTHORA := 0;

			WHILE V_CONTHORA <= 23 LOOP
				UPDATE METAHORA 
					SET VRPERCHORA = TRUNC(V_HORAS(V_CONTHORA + 1), 2)
					WHERE CDFILIAL = V_CDFILIAL 
						AND CDHORA = V_CONTHORA 
						AND NRDIA = V_NRDIA 
						AND CDMES = V_CDMES 
						AND CDANO = V_CDANO 
						AND NRORG = V_NRORG;
				V_CONTHORA := V_CONTHORA + 1;
			END LOOP;

			IF(V_VENDASEMANA > 0) THEN
				UPDATE METADIA 
					SET VRTICKETDIA = V_TICKETMEDIO
					WHERE CDFILIAL = V_CDFILIAL 
						AND NRDIA = J 
						AND CDMES = V_CDMES 
						AND CDANO = V_CDANO 
						AND NRORG = V_NRORG;
			END IF;
		/* END LOOP DE DIAS DA SEMANA */
		END LOOP;

		IF(V_VENDASEMANA > 0) THEN
			FOR i IN 1..7 LOOP
				V_VND_PROV := (V_VALORES(i) * 100) / V_VENDASEMANA;

				UPDATE METADIA 
					SET VRPERCDIA = TRUNC(V_VND_PROV, 2)
				WHERE CDFILIAL = V_CDFILIAL 
					AND NRDIA = i 
					AND CDMES = V_CDMES 
					AND CDANO = V_CDANO 
					AND NRORG = V_NRORG;
			END LOOP;
		END IF;

		UPDATE METAMES 
			SET VRMES = TRUNC(V_TOTVENDAMES, 2), 
				VRSEM = TRUNC(V_VENDASEMANA, 2)
			WHERE CDFILIAL = V_CDFILIAL 
				AND CDMES = V_CDMES 
				AND CDANO = V_CDANO 
				AND NRORG = V_NRORG;
	/* END LOOP MES */
	END LOOP;
	COMMIT;
	CALCULA_METAS_RM(V_CDFILIAL, V_NRORG, V_CDANO);
END;